<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         modify_user.php
Description:  Administrative module to unlock/lock/delete an user/customer

*/

    include "../modules/class_user.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";

    $bUserLoadFailed = false;
    $usrId = "";
    $usrModAction = "unlock";
    $errorString = "";
    
    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if ($usrModAction == "delete" && (user_is_admin() == false && $usrMode == "user"))
    {
        header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
        return;
    }

    // Get action
    if (isset ($_POST['usr_action']) == true)
    {
        if ($_POST['usr_action'] == "lock")
            $usrModAction = "lock";
        else if ($_POST['usr_action'] == "delete")
            $usrModAction = "delete";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "lock")
            $usrModAction = "lock";
        else if ($_GET['action'] == "delete")
            $usrModAction = "delete";
    }

    // User/customer mode?
    $usrMode="user";
    if (isset($_GET['mode']) && $_GET['mode'] != "")
        $usrMode = $_GET['mode'];
    else if (isset($_POST['usr_mode']) && $_POST['usr_mode'] != "")
        $usrMode = $_POST['usr_mode'];
    $usrUser = new cUser;
    if ($usrMode == "user")
        $usrUser->SetFolder($USER_FOLDER);
    else
    {
        $usrUser->SetFolder($CUSTOMER_FOLDER);
        $usrUser->SetFolderDeleted($CUSTOMER_FOLDER_DELETED);
    }
    if (isset ($_POST['usr_id']) == true)
        $usrId = $_POST['usr_id'];
    else if (isset ($_GET['id']) == true)
        $usrId = $_GET['id'];

    if ($usrUser->LoadUserFromId($usrId) == false)
    {
        print_error_message($cTrans->GetTranslation('admin_usrmod_errorload') . ' ' . $usrId . '!!');
        $bUserLoadFailed = true;
    }

    // Cancel modification?
    if (isset ($_POST['usr_Cancel']))
    {
        header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
        return;
    }
    // Modify user?
    if (isset ($_POST['usr_DoAction']) && $bUserLoadFailed == false)
    {
        if ($usrModAction == "lock")
        {
            if ($usrUser->SetLocked(true) == false)
                $errorString = $cTrans->GetTranslation('admin_usrmod_errorlock') . ' ' . $usrId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' locked user ' . $usrUser->GetId());
                header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
                return;
            }
        }
        else if ($usrModAction == "delete")
        {
            $bDone = false;
            if ($usrMode == "user")
                $bDone = $usrUser->DeleteUserFinalX();  // Users can be unlinked
            else
                $bDone = $usrUser->DeleteUserFinal();  // Customers not
            if ($bDone == false)
                $errorString = $cTrans->GetTranslation('admin_usrmod_errordelete') . ' ' . $usrId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' deleted user ' . $usrUser->GetId());
                header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
                return;
            }
        }
        else
        {
            if ($usrUser->SetLocked(false) == false)
                $errorString = $cTrans->GetTranslation('admin_usrmod_errorunlock') . ' ' . $usrId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' unlocked user ' . $usrUser->GetId());
                header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
                return;
            }
        }
    }

    // Display
    $titleString = $cTrans->GetTranslation('admin_usrmod_unlockhead');
    if ($usrModAction == "lock")
        $titleString = $cTrans->GetTranslation('admin_usrmod_lockhead');
    else if ($usrModAction == "delete")
        $titleString = $cTrans->GetTranslation('admin_usrmod_deletehead');
    if ($usrMode != "user")
    {
        $titleString = $cTrans->GetTranslation('admin_usrmod_unlockheadcust');
        if ($usrModAction == "lock")
            $titleString = $cTrans->GetTranslation('admin_usrmod_lockheadcust');
        else if ($usrModAction == "delete")
            $titleString = $cTrans->GetTranslation('admin_usrmod_deleteheadcust');
    }
    if ($usrMode == "user")
        print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                           $ADMIN_USRLIST_SITE . '?mode=' . $usrMode, $cTrans->GetTranslation('admin_usrl_button'));
    else
        print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                           $ADMIN_USRLIST_SITE . '?mode=' . $usrMode, $cTrans->GetTranslation('admin_usrl_buttoncustomer'));

    if ($errorString != "")
        print_error_message($errorString);
        
    if ($usrModAction == "lock")
        echo_r('<p>' . $cTrans->GetTranslation('admin_usrmod_questlock') . ':</p><br>');
    else if ($usrModAction == "delete")
        echo_r('<p>' . $cTrans->GetTranslation('admin_usrmod_questdelete') . ':</p><br>');
    else
        echo_r('<p>' . $cTrans->GetTranslation('admin_usrmod_questunlock') . ':</p><br>');
    echo_r('<table width="100%" border="0">');
    echo_r('  <tr>');
    echo_r('    <td width="40%">');
        if ($usrUser->GetType() == $USERTYPE_CUSTOMER)
            echo_r('       <img src="' . $CUSTOMER_IMAGE . '" alt="">');
        else if ($usrUser->GetType() == $USERTYPE_REPORTER)
            echo_r('       <img src="' . $REPORTER_IMAGE . '" alt="">');
        else if ($usrUser->GetType() == $USERTYPE_SITEOWNER)
            echo_r('       <img src="' . $OWNER_IMAGE . '" alt="">');
        else if ($usrUser->GetType() == $USERTYPE_ADMINISTRATOR)
            echo_r('       <img src="' . $ADMIN_IMAGE . '" alt="">');
    echo_r('    </td>');
    echo_r('    <td width="60%">');
    echo_r('       ' . $cTrans->GetTranslation('admin_usr_id') . ': ' . $usrUser->GetId() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_usr_date') . ': ' . $usrUser->GetDate() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_usr_alias') . ': ' . $usrUser->GetAlias() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_usr_email') . ': ' . $usrUser->GetEmail() . '<br>');
        echo_r('       ' . $cTrans->GetTranslation('admin_usr_type') . ': ');
        if ($usrUser->GetType() == 0)
            echo_r($cTrans->GetTranslation('admin_usr_typecustomer') . '<br>');
        else if ($usrUser->GetType() == 1)
            echo_r($cTrans->GetTranslation('admin_usr_typereporter') . '<br>');
        else if ($usrUser->GetType() == 2)
            echo_r($cTrans->GetTranslation('admin_usr_typeowner') . '<br>');
        else if ($usrUser->GetType() == 3)
            echo_r($cTrans->GetTranslation('admin_usr_typeadmin') . '<br>');
    echo_r('    </td>');
    echo_r('  </tr>');
    echo_r('</table>');
    
    echo_r('<form method="post" action="">');
    print_bottom_links("usr_DoAction", $cTrans->GetTranslation('admin_yes'),
                       "usr_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('  <input type="hidden" value="' .  $usrId . '" name="usr_id">  ');
    echo_r('  <input type="hidden" value="' .  $usrModAction . '" name="usr_action">  ');
    echo_r('<input type="hidden" name="usr_mode" value="' . $usrMode . '">');
    echo_r('</form>');

    print_admin_footer();
?>