<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_article_detail.php
Description:  Shop detail of article

*/
    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    // Check for maintenance mode...
    if ($SHOP_MAINTENANCE_MODE == true)
    {
        include $ADMIN_MAINTENANCE_SITE;
        return;
    }

    // Check for login...
    if (check_login() == false && $FORCE_CUSTOMER_LOGIN == true)
    {
        header ("location: " . $SHOP_LOGIN_SITE);
        return;
    }

    include "../modules/class_article.php";
    include "../modules/class_articlelist.php";
    include "../modules/class_basket.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    // Session starts first :-)
    $basket = new cBasket;
    $basket->InitSession();
    $basket->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $basket->LoadFromSession();
    $basket->SaveToSession();

    $cFile = new cTextFile;

    $art = new cArticle;
    $art->SetFolder($ARTICLE_FOLDER);
    $art->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $artId = "";
    $artAddImg = 0;
    $errorMessage = "";

    // No id, no detail :-)
    if (isset($_GET['art_id']) == false && isset($_POST['art_id']) == false)
    {
        header ("location: " . $SHOP_MAIN_SITE);
        return;
    }
    if (isset($_GET['art_id']) == true)
        $artId = $_GET['art_id'];
    if (isset($_POST['art_id']) == true)
        $artId = $_POST['art_id'];
    if (isset($_GET['add_img']) == true)
        $artAddImg = $_GET['add_img'];


    if ($art->LoadArticleFromId($artId) == false || $art->IsLocked() || ($USE_ARTICLE_AMOUNTS == true && $art->IsArticleSoldOut() == true))
    {
        header ("location: " . $SHOP_MAIN_SITE);
        return;
    }
    $art->IncreaseViewCount();  // Statistic

    // Add to basket / buy now
    if (isset($_POST['art_AddBasket']) == true || isset($_POST['art_BuyNow']) == true)
    {
        if ($artId != "" && isset($_POST['art_count']))
        {
            $artCount = $_POST['art_count'];
            if ($artCount == "" || is_numeric($artCount) == false)
                $artCount = "1";
            else if ($artCount < 1)
                $artCount = "1";

            // Check maximum article amount
            if ($artCount > $SHOP_MAX_ARTICLE_COUNT)
            {
                $artCount = $SHOP_MAX_ARTICLE_COUNT;
                $errorMessage = $cTrans->GetTranslation('shop_detail_errormaxcount');
            }
            // Check available article amount
            if ($USE_ARTICLE_AMOUNTS == true && ($art->IsArticleAmountUnlimited() == false && $artCount > $art->GetArticleAmount()))
            {
                $artCount = $art->GetArticleAmount();
                $errorMessage = $cTrans->GetTranslation('shop_detail_errormaxamount');
            }
            $artAddToPrice = $_POST['art_addtoprice'];
            if ($artAddToPrice == "" || is_numeric($artAddToPrice == false))
                $artAddToPrice = "0";
            $artCNames = array();
            $artCValues = array();
            for ($i = 1; $i <= $ARTICLE_CUSTOM_FIELD_COUNT; $i ++)
            {
                $artCNames[] = $_POST['art_cust_name' . $i];
                $artCValues[] = $_POST['art_cust_val' . $i];
            }
            if ($basket->AddArticle($artId, $artCount, $art->GetPrice(), $art->GetName(), $artAddToPrice, $artCNames, $artCValues) == true)
            {
                $basket->SaveToSession();
                if ($errorMessage == "")
                {
                    if (isset($_POST['art_BuyNow']) == true)  // Buy now
                        header("location: " . $SHOP_ORDER_SITE);
                    else  // Add to basket
                        header("location: " . $SHOP_MAIN_SITE);
                    return;
                }
            }
        }
    }

    // Display article details
    $contPage = build_page($SHOP_THEME, false, true, true, "");
    $contPage = fill_titles($contPage, $art->GetName() . ' - ' . $SHOP_TITLE, $art->GetName());

    // Error occured?
    if ($errorMessage != "")
        $contPage = build_error_message($errorMessage, $contPage);

    // Main content
    $contMain = build_shop_login();
    $contMain .= $cFile->LoadFromFile($DETAILSTITLE_CONFIG_FILE);
    $contMain .= echo_sr ('<form method="post" action="">');
    if ($SHOP_SIDEBAR == true)
    {
        $contMain .= echo_sr ('<table class="con_sidebar_tbl" width="100%" border="0">');
        $contMain .= echo_sr ('<tr><td class="con_sidebar_tbltd_left" style="vertical-align: top">');
    }
    $contMain .= echo_sr ('<table class="con_tbl" id="details_con_tbl">');
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('   <td width="20%">');
    // Show additional images as thumbs?
    if ($USE_ARTICLE_ADDITIONAL_IMAGES == true)
    {
        $artAddImages = array();
        for ($i = 1; $i <= $ARTICLE_ADDITIONAL_IMAGES_COUNT; $i ++)
        {
            if (file_exists($art->GetAddImgThumbUrl($i)) == true)
                $artAddImages[] = array($art->GetAddImgThumbUrl($i), $i);
        }
        if (count($artAddImages) > 0)  // Additional images?
        {
            $contMain .= echo_sr ('    ' . $cTrans->GetTranslation('shop_detail_mainimage') . ':<br>');
            $contMain .= echo_sr ('    <a href="' . $SHOP_DETAIL_SITE . '?art_id=' . $artId . '"><img class="detail_thumbimg" src="' . $art->GetImgThumbUrl() . '" width="' . $THUMB_IMAGE_WIDTH . '" height="' . $THUMB_IMAGE_HEIGHT . '"></a>');
            $contMain .= echo_sr ('    <br><br>' . $cTrans->GetTranslation('shop_detail_addimages') . ':<br>');
            for ($i = 0; $i < count($artAddImages); $i ++)
            {
                $contMain .= echo_sr ('    <a href="' . $SHOP_DETAIL_SITE . '?art_id=' . $artId . '&amp;add_img=' . $artAddImages[$i][1] . '"><img src="' . $artAddImages[$i][0] . '" width="' . $THUMB_IMAGE_WIDTH . '" height="' . $THUMB_IMAGE_HEIGHT . '"></a>');
            }
        }
    }
    $contMain .= echo_sr ('   </td>');
    $contMain .= echo_sr ('   <td width="60%"><center>');
    // Specific -->
    $imgAltText = $art->GetName() . ' - ' . $SHOP_TITLE;
    $imgTitle = $art->GetName() . ' - ' . $cTrans->GetTranslation('shop_detail_preview');
    $imgMainUrl = $art->GetImgURL();
    // Replace main image by additional one?
    if ($USE_ARTICLE_ADDITIONAL_IMAGES == true && $artAddImg > 0)
    {
        if (file_exists($art->GetAddImgUrl($artAddImg)) == true)
            $imgMainUrl = $art->GetAddImgUrl($artAddImg);
    }
    $contMain .= echo_sr ('     <img class="detail_img" src="' . $imgMainUrl . '" width="' . $NORM_IMAGE_WIDTH . '" height="' . $NORM_IMAGE_HEIGHT . '" alt="' . $imgAltText . '" title="' . $imgTitle . '" style="cursor: pointer;" onClick="document.getElementById(\'art_Preview_btn\').click();">');
    // <-- Specific
    $contMain .= echo_sr ('   </center><br></td>');
    $contMain .= echo_sr ('   <td width="20%"><p align="left">');
    // Custom fields
    $addToPrice = 0;
    for ($i = 1; $i <= $ARTICLE_CUSTOM_FIELD_COUNT; $i ++)
    {
        // Custom values
        // Multiple selectors
        if ($art->GetCustFieldName($i) != "" && $art->GetCustFieldValue($i) != "")
        {
            $contMain .= echo_sr ('      <br>' . $art->GetCustFieldName($i) . ':<br>');
            $contMain .= echo_sr ('      <select name="art_cust_val' . $i . '" id="cust_val' . $i . '" onChange="submit();">');
            $arr_custval = split(";", $art->GetCustFieldValue($i));
            $imageName = "";
            $priceAdd = 0;
            $count = 0;
            foreach ($arr_custval as $value)
            {
                $arr_value = split("\|", $value); // for additional parameter
                // Preset: first value
                if ($count == 0 && (isset($arr_value[1]) && $arr_value[1] != ""))
                {
                    if ($arr_value[1][0] != '+')  // image
                        $imageName = $arr_value[1];
                    else
                        $priceAdd = $arr_value[1];  // add to price
                }
                $contMain .= ('        <option value="' . $arr_value[0] . '"');
                if (isset($_POST['art_cust_val'. $i]) == false)
                    $_POST['art_cust_val'. $i] = $arr_value[0];
                if (isset($_POST['art_cust_val'. $i]) && $_POST['art_cust_val'. $i] == $arr_value[0])
                    $contMain .= (' selected');
                $contMain .= echo_sr ('>' . $arr_value[0] . '</option>');
                // Check if value is not already set by post
                if ((isset($arr_value[1]) && $arr_value[1] != ""))
                {
                    if (isset($_POST['art_cust_val'. $i]) && $_POST['art_cust_val'. $i] == $arr_value[0])
                    {
                        if ($arr_value[1][0] != '+')  // image
                            $imageName = $arr_value[1];
                        else
                            $priceAdd = $arr_value[1];
                    }
                }
                $count ++;
            }
            $contMain .= echo_sr ('      </select>');
            if ($imageName != "")  // image
                $contMain .= echo_sr ('      <br><img src="' . $ARTICLE_IMAGES_FOLDER . $imageName . '" alt="">');
            if ($priceAdd != 0)  // add to price
                $addToPrice += $priceAdd;

        }
        else if ($art->GetCustFieldName($i) != "")  // Single input fields
        {
            $contMain .= echo_sr ('      <br>' . $art->GetCustFieldName($i) . ':<br>');
            if (isset($_POST['art_cust_val' . $i]) == true)
                $contMain .= echo_sr ('      <input type="text" name="art_cust_val' . $i . '" id="cust_val' . $i . '" value="' . $_POST['art_cust_val' . $i] . '">');
            else
            {
                $contMain .= echo_sr ('      <input type="text" name="art_cust_val' . $i . '" id="cust_val' . $i . '" value="">');
                $_POST['art_cust_val' . $i] = "";
            }
        }
        else
            $contMain .= echo_sr ('      <input type="hidden" name="art_cust_val' . $i . '" id="cust_val' . $i . '" value="">');
        // Custom names
        $contMain .= echo_sr ('      <input type="hidden" name="art_cust_name' . $i . '" id="cust_name' . $i . '" value="' . $art->GetCustFieldName($i) . '">');
    }
    $contMain .= echo_sr ('   </p></td>');
    $contMain .= echo_sr ('</tr>');
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('   <td width="20%">' . $cTrans->GetTranslation('shop_detail_name') . ':</td>');
    $contMain .= echo_sr ('   <td width="60%">' . $art->GetName() . '</td>');
    $contMain .= echo_sr ('   <td width="20%"></td>');
    $contMain .= echo_sr ('</tr>');
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('   <td width="20%">' . $cTrans->GetTranslation('shop_detail_description') . ':</td>');
    $contMain .= echo_sr ('   <td width="60%">' . $art->GetDescription() . '</td>');
    $contMain .= echo_sr ('   <td width="20%"></td>');
    $contMain .= echo_sr ('</tr>');
    if ($art->GetVideo() != "")
    {
        $contMain .= echo_sr ('<tr>');
        $contMain .= echo_sr ('   <td width="20%">' . $cTrans->GetTranslation('shop_detail_video') . ':</td>');
        $contMain .= echo_sr ('   <td width="60%">' . $art->GetVideo() . '</td>');
        $contMain .= echo_sr ('   <td width="20%"></td>');
        $contMain .= echo_sr ('</tr>');
    }
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('   <td width="20%">' . $cTrans->GetTranslation('shop_detail_price') . ':</td>');
    $contMain .= echo_sr ('   <td width="60%">' . format_price($art->GetPrice() + $addToPrice) . ' ' . $SHOP_CURRENCY . '</td>');
    $contMain .= echo_sr ('   <td width="20%"></td>');
    $contMain .= echo_sr ('</tr>');
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('   <td width="20%">' . $cTrans->GetTranslation('shop_detail_count') . ':</td>');
    $contMain .= echo_sr ('   <td width="60%">');
    $contMain .= echo_sr ('     <table width="100%" border="0"><tr>');
    $contMain .= echo_sr ('      <td width="10%"><input type="text" name="art_count" size="3" maxlength="8" value="1"></td>');
    $contMain .= echo_sr ('      <td width="80%">');
    $contMain .= echo_sr ('         <center><input type="submit" class="bottom_btn" id="art_AddBasket_btn" name="art_AddBasket" value="' . $cTrans->GetTranslation('shop_detail_addtobasket') . '">');
    $contMain .= echo_sr ('         <input type="submit" class="bottom_btn" id="art_BuyNow_btn" name="art_BuyNow" value="' . $cTrans->GetTranslation('shop_detail_buynow') . '"></center>');
    $contMain .= echo_sr ('      </td>');
    $contMain .= echo_sr ('      <td width="10%"></td>');
    $contMain .= echo_sr ('   </tr></table>');
    $contMain .= echo_sr ('   </td>');
    $contMain .= echo_sr ('   <td width="20%">');
    // Specific -->
    $link = $SHOP_PREVIEW_SITE . '?id=' . $artId;
    $contMain .= echo_sr ('<script type="text/javascript" language="JavaScript">');
    $contMain .= echo_sr ('function openPreview(link)');
    $contMain .= echo_sr ('{');
    $contMain .= echo_sr ('   for (i = 1; i <= 5; i ++)');
    $contMain .= echo_sr ('   {');
    $contMain .= echo_sr ('     link = link + "&v" + i + "=" + document.getElementById("cust_val" + i).value;');
    // Replace main image by additional one?
    if ($USE_ARTICLE_ADDITIONAL_IMAGES == true && $artAddImg > 0 && file_exists($art->GetAddImgLargeUrl($artAddImg)) == true)
        $contMain .= echo_sr ('     link = link + "&add_img=' . $artAddImg . '";');
    $contMain .= echo_sr ('   }');
    $contMain .= echo_sr ('   window.open(link, "", "fullscreen, scrollbars=yes");');
    $contMain .= echo_sr ('}');
    $contMain .= echo_sr ('</script>');
    $contMain .= echo_sr ('         <input type="button" class="bottom_btn" id="art_Preview_btn" name="art_Preview" value="' . $cTrans->GetTranslation('shop_detail_preview') . '" onClick="openPreview(\'' . $link . '\');">');
    // <-- Specific
    $contMain .= echo_sr ('   </td>');
    $contMain .= echo_sr ('</tr>');
    $contMain .= echo_sr ('</table>');
    if ($SHOP_SIDEBAR == true)
    {
        $contMain .= echo_sr ('</td><td class="con_sidebar_tbltd_right" style="vertical-align: top">');
        $contMain .= build_shop_sidebar($artId);
        $contMain .= echo_sr ('</td></tr>');
        $contMain .= echo_sr ('</table>');
    }
    $contMain .= echo_sr('<input type="hidden" name="art_id" value="' . $artId . '">');
    $contMain .= echo_sr('<input type="hidden" name="art_addtoprice" value="' . $addToPrice . '">');
    $contMain .= echo_sr('</form>');

    // Additional content
    $contAdditional = "";

    // Put content together
    $contContent = build_site_content($ALIGN_TOP, $contMain, $contAdditional);
    $contPage = fill_content($contPage, $contContent, "", "");
    $contPage = fill_emptyvars($contPage);

    echo_r($contPage);

?>