<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_article_preview.php
Description:  Artice preview

*/
    include "../modules/class_article.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";
    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    $artArticle = new cArticle;
    $artArticle->SetFolder($ARTICLE_FOLDER);
    $artId = 0;
    $artAddImg = 0;

    $cFile = new cTextFile;

    // Close window?
    if (isset($_POST['artp_Close']) == true)
    {
        echo_r('<script language="JavaScript">close();</script>');
        return;
    }

    if (isset($_GET['id']) == false || isset($_GET['v1']) == false || isset($_GET['v2']) == false || isset($_GET['v3']) == false)
    {
        print_error_message($cTrans->GetTranslation('shop_preview_error'));
        return;
    }
    $artId = $_GET['id'];
    if (isset($_GET['add_img']) == true)
        $artAddImg = $_GET['add_img'];

    if ($artArticle->LoadArticleFromId($artId) == false || $artArticle->IsLocked())
    {
        print_error_message($cTrans->GetTranslation('shop_preview_error') . ' (Id=' . $artId . ')');
        return;
    }

    // Get background image
    $imageName = "";
    $arr_custval = split(";", $artArticle->GetCustFieldValue(1));
    foreach ($arr_custval as $value)
    {
        $arr_value = split("\|", $value); // for additional parameter
        if ($arr_value[0] == $_GET['v1'])
        {
            if (isset($arr_value[1]) == true)
                $imageName = $ARTICLE_IMAGES_FOLDER . $arr_value[1];
        }
    }
    // Get font name
    $fontName = "";
    $arr_custval = split(";", $artArticle->GetCustFieldValue(2));
    foreach ($arr_custval as $value)
    {
        $arr_value = split("\|", $value); // for additional parameter
        if ($arr_value[0] == $_GET['v2'])
        {
            if (isset($arr_value[1]) == true)
                $fontName = $ARTICLE_IMAGES_FOLDER . substr($arr_value[1], 0, -4);
        }
    }

    echo_r('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
    echo_r('<html>');
    echo_r('<head><title>' . $SHOP_TITLE . '</title>');
    echo_r('<link rel="stylesheet" type="text/css" href="theme.css">');
    echo_r('<meta name="author" content="Alternate Tools">');
    echo_r('<meta http-equiv="content-type" content="text/html; charset=' . $SHOP_CHARSET_FORMAT . '">');
    echo_r('</head>');
    echo_r('<body>');

    $headText = $cFile->LoadFromFile($PREVIEWTITLE_CONFIG_FILE);
    echo_r('<table width="100%" border="0" cellspacing="0" cellpadding="0" class="preview_tbl">');
    echo_r('<tr style="vertical-align:top">');
    echo_r('<td width="15%" class="preview_tbltd">' . $headText);
    echo_r('</td>');
    echo_r('<td width="70%" class="preview_tbltd2">');
    echo_r('<center>');
    echo_r('<p>' . $artArticle->GetName() . '</p>');
    echo_r('<table width="' . $LARGE_IMAGE_WIDTH . '" border="0" class="preview_main_tbl">');
    echo_r('<tr style="background:url(' . $imageName . ')">');
    $imgAltText = $artArticle->GetName() . ' ' . $cTrans->GetTranslation('shop_preview_title') . ' - ' . $SHOP_TITLE;
    $imgMainUrl = $artArticle->GetImgLargeUrl();
    // Replace main image by additional one?
    if ($USE_ARTICLE_ADDITIONAL_IMAGES == true && $artAddImg > 0)
    {
        if (file_exists($artArticle->GetAddImgLargeUrl($artAddImg)) == true)
            $imgMainUrl = $artArticle->GetAddImgLargeUrl($artAddImg);
    }
    echo_r('<td><img class="preview_img" src="' . $imgMainUrl . '" alt="' . $imgAltText . '"></td>');
    echo_r('</tr>');
    echo_r('</table>');
    echo_r('<table border="0" class="preview_special_tbl">');
    echo_r('<tr style="background:url(' . $imageName . '); text-align: center">');
    // Build the entered text string
    if ($_GET['v3'] != "" && $fontName != "")
    {
        echo_r('<td>');
        $textString = $_GET['v3'];
        for ($i = 0; $i < strlen($textString); $i ++)
        {
            $charName = $fontName . '_' . sprintf('%03d', ord($textString[$i])) . '.gif';
            echo ('<img src="' . $charName . '" alt="">');
        }
        echo_r('</td>');
    }
    else
        echo_r('<td></td>');
    echo_r('</tr>');
    echo_r('</table>');
    echo_r('</center>');
    echo_r('</td>');
    echo_r('<td width="15%">');
    echo_r('<form method="post" action="">');
    echo_r('<input type="submit" class="bottom_btn" name="artp_Close" value="' . $cTrans->GetTranslation('shop_preview_close') . '">');
    echo_r('</form>');
    echo_r('</td>');
    echo_r('</tr>');
    echo_r('</table>');
    echo_r('</body>');
    echo_r('</html>');
?>