<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_userprofile.php
Description:  Shop user profile (customers) site

*/

    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    // Check for maintenance mode...
    if ($SHOP_MAINTENANCE_MODE == true)
    {
        include $ADMIN_MAINTENANCE_SITE;
        return;
    }

    // Check for login...
    $checkLogin = false;
    if (isset ($_POST['usr_Save']) == false)
        $checkLogin = check_login();
    else
        session_start();

    include "../modules/class_translation.php";
    include "../modules/class_userlist.php";
    include "../modules/class_user.php";
    
    $b_ErrorOccured = false;
    $usrId = "";
    $errorMessage = "";

    // Check back to order
    $usrBackToOrder = false;
    if (isset ($_POST['usr_BackToOrder']) == true)
        $usrBackToOrder = true;
    else if (isset ($_GET['backtoorder']) == true)
        $usrBackToOrder = true;

    // Check action
    $usrEdtAction = "new";
    if (isset ($_POST['usr_EdtAction']) == true)
    {
        if ($_POST['usr_EdtAction'] == "edit")
            $usrEdtAction = "edit";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "edit")
            $usrEdtAction = "edit";
    }

    $usrUser = new cUser;
    $usrList = new cUserList;
    $usrUser->SetFolder($CUSTOMER_FOLDER);
    $usrUser->SetFolderDeleted($CUSTOMER_FOLDER_DELETED);
    $usrList->SetFolder($CUSTOMER_FOLDER);
    
    if ($usrEdtAction == "edit")  // Edit -> load it
    {
        $usrId = $usrList->GetUserIdByAlias(get_user_name());
        if ($usrUser->LoadUserFromId($usrId) == false)
        {
            print_error_message($cTrans->GetTranslation('shop_userprofile_errorload') . ' ' . $usrId);
            return;
        }
    }

    // User profile edit cancelled?
    if (isset ($_POST['usr_Cancel']))
    {
        header('location: ' . $SHOP_MAIN_SITE);
        return;
    }

    // Delete user profile?
    if (isset ($_POST['usr_DeleteFinal']))
    {
        if ($usrUser->DeleteUserFinal() == true)
        {
            log_message ('User ' . get_user_name() . ' deleted user profile ' . $usrUser->GetId());
            log_out();
            header('location: ' . $SHOP_MAIN_SITE);
            return;
        }
        $errorMessage = $cTrans->GetTranslation('shop_userprofile_errordelete') . '!';
        $b_ErrorOccured = true;
    }

    // Check for errors and if none, store the user profile values
    if (isset ($_POST['usr_Save']))
    {
        $usrl_UserList = new cUserList;
        $usrl_UserList->SetFolder($CUSTOMER_FOLDER);
        $usrId = "";
        if (isset($_POST['usr_id']))
            $usrId = $_POST['usr_id'];
        // Alias
        if ($_POST['usr_alias'] == "")
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_erroralias') . '!';
            $b_ErrorOccured = true;
        }
        if ($usrl_UserList->CheckAlias($_POST['usr_alias'], $usrId) == false)
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_erroraliasexits') . '!';
            $b_ErrorOccured = true;
        }
        // Password
        if ($b_ErrorOccured == false && ($_POST['usr_password'] == "" || $_POST['usr_passwordconf'] == ""))
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_errorpassword') . '!';
            $b_ErrorOccured = true;
        }
        if ($b_ErrorOccured == false && ($_POST['usr_password'] != $_POST['usr_passwordconf']))
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_errorpassconf') . '!';
            $b_ErrorOccured = true;
        }
        // Checksum
        if (($b_ErrorOccured == false && $usrEdtAction != "edit") &&
            ((isset($_POST['usr_checksum']) == false || isset($_POST['usr_checksum_org']) == false ||
             ($_POST['usr_checksum'] != $_POST['usr_checksum_org']))))
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_errorchecksum') . '!';
            $b_ErrorOccured = true;
        }
        // Address
        if ($b_ErrorOccured == false && (!ereg("^.+@.+\\..+$", $_POST['usr_email'])))
        {
            $errorMessage = $cTrans->GetTranslation('shop_userprofile_erroremail') . '!';
            $b_ErrorOccured = true;
        }
        if ($b_ErrorOccured == false)
        {
            $missingElement = "";
            if ($_POST['usr_firstname'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_firstname');
            if ($_POST['usr_lastname'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_lastname');
            if ($_POST['usr_street'] == "")
                $missingElement = $missingElement . '<br> -> ' . $cTrans->GetTranslation('shop_userprofile_street');
            if ($_POST['usr_streetno'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_streetno');
            if ($_POST['usr_city'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_city');
            if ($_POST['usr_zipcode'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_zipcode');
            if ($_POST['usr_land'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_land');
            if ($_POST['usr_phoneno'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_phoneno');
            if ($_POST['usr_email'] == "")
                $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('shop_userprofile_email');

            if ($missingElement != "")
            {
                $errorMessage = $cTrans->GetTranslation('shop_userprofile_erroraddress') . ': ' . $missingElement;
                $b_ErrorOccured = true;
            }
        }

        if ($b_ErrorOccured == false)
        {
            // If done, fill the rest of the parameters
            if ($usrEdtAction == "new")    // New -> create Id first
            {
                $usrUser->CreateUser();
                $usrUser->SetFolder($CUSTOMER_FOLDER);
            }
            $usrUser->SetAlias($_POST['usr_alias']);
            log_in($_POST['usr_alias'], $USERTYPE_CUSTOMER);
            if ($_POST['usr_password'] != $usrUser->GetPassword())  // Only if changed, cause of MD5
                $usrUser->SetPassword($_POST['usr_password']);
            $usrUser->SetType($USERTYPE_CUSTOMER);
            $usrUser->SetFirstName($_POST['usr_firstname']);
            $usrUser->SetLastName($_POST['usr_lastname']);
            $usrUser->SetStreet($_POST['usr_street']);
            $usrUser->SetStreetNo($_POST['usr_streetno']);
            $usrUser->SetCity($_POST['usr_city']);
            $usrUser->SetZipCode($_POST['usr_zipcode']);
            $usrUser->SetLand($_POST['usr_land']);
            $usrUser->SetTelephoneNo($_POST['usr_phoneno']);
            $usrUser->SetEmail($_POST['usr_email']);
            if (isset($_POST['usr_newsletter']))
                $usrUser->SetWantsNewsletter($_POST['usr_newsletter'] == "1");
            else
                $usrUser->SetWantsNewsletter(false);
            if ($usrUser->SaveUser() == false)
            {
                if ($usrEdtAction == "new")
                    $errorMessage = $cTrans->GetTranslation('shop_userprofile_errorcreate') . '!';
                else
                    $errorMessage = $cTrans->GetTranslation('shop_userprofile_errorsave') . '!';
                $b_ErrorOccured = true;
            }
            else
            {
                // User is saved.
                if ($usrEdtAction == "edit")
                    log_message ('User ' . get_user_name() . ' saved user profile ' . $usrUser->GetId());
                else
                {
                    log_message ('User ' . $usrUser->GetAlias() . ' created user profile ' . $usrUser->GetId());
                    log_in($usrUser->GetAlias(), $usrUser->GetType());
                    log_message ('User ' . get_user_name() . ' logged in');
                    // Link back to order page?
                    if ($usrBackToOrder == true)
                    {
                        header ('Location: ' . $SHOP_ORDER_SITE);
                        return;
                    }
                }
                header ('Location: ' . $SHOP_MAIN_SITE);
                return;
            }
        }
    }

    // Display userprofile edit site
    $contPage = build_page($SHOP_THEME, false, true, true, "");
    if ($usrEdtAction == "edit")  // Edit
        $contTitle = $cTrans->GetTranslation('shop_userprofile_edithead');
    else
        $contTitle = $cTrans->GetTranslation('shop_userprofile_newhead');
    $contPage = fill_titles($contPage, $SHOP_TITLE, $SHOP_TITLE . $contTitle);

    // Error occured?
    if ($errorMessage != "")
        $contPage = build_error_message($errorMessage, $contPage);

    // Main content
    $contMain = "";
    $contMain .= echo_sr ('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    $contMain .= echo_sr ('<table width="100%" class="con_tbl" id="usr_con_tbl">');
    if ($usrEdtAction == "edit")  // Edit
    {
        $contMain .= echo_sr ('  <tr>');
        $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_id') . ':</td>');
        $contMain .= echo_sr ('    <td><b>' . $usrUser->GetId() . '</b>');
        $contMain .= echo_sr ('      <input type="hidden" value="' .  $usrUser->GetId() . '" name="usr_id">  ');
        $contMain .= echo_sr ('    </td>');
        $contMain .= echo_sr ('  </tr>');
    }
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td width="30%">' . $cTrans->GetTranslation('shop_userprofile_alias') . ':</td>');
    if (isset($_POST['usr_alias']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_alias" size="30" value="' . $_POST['usr_alias'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_alias" size="30" value="' .  $usrUser->GetAlias() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_password') . ':</td>');
    if (isset($_POST['usr_password']))
        $contMain .= echo_sr ('    <td><input type="password" name="usr_password" size="30" value="' . $_POST['usr_password'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="password" name="usr_password" size="30" value="' . $usrUser->GetPassword() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_passwordconf') . ':</td>');
    if (isset($_POST['usr_passwordconf']))
        $contMain .= echo_sr ('    <td><input type="password" name="usr_passwordconf" size="30" value="' . $_POST['usr_passwordconf'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="password" name="usr_passwordconf" size="30" value="' . $usrUser->GetPassword() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr><td>' . $cTrans->GetTranslation('shop_userprofile_address') . ':</td><td><br></td></tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_firstname') . ':</td>');
    if (isset($_POST['usr_firstname']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_firstname" size="30" value="' . $_POST['usr_firstname'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_firstname" size="30" value="' . $usrUser->GetFirstName() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_lastname') . ':</td>');
    if (isset($_POST['usr_lastname']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_lastname" size="30" value="' . $_POST['usr_lastname'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_lastname" size="30" value="' . $usrUser->GetLastName() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_street') . ':</td>');
    if (isset($_POST['usr_street']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_street" size="30" value="' . $_POST['usr_street'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_street" size="30" value="' . $usrUser->GetStreet() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_streetno') . ':</td>');
    if (isset($_POST['usr_streetno']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_streetno" size="5" value="' . $_POST['usr_streetno'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_streetno" size="5" value="' . $usrUser->GetStreetNo() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_zipcode') . ':</td>');
    if (isset($_POST['usr_zipcode']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_zipcode" size="10" value="' . $_POST['usr_zipcode'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_zipcode" size="10" value="' . $usrUser->GetZipCode() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_city') . ':</td>');
    if (isset($_POST['usr_city']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_city" size="30"  value="' . $_POST['usr_city'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_city" size="30"  value="' . $usrUser->GetCity() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_land') . ':</td>');
    if (isset($_POST['usr_land']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_land" size="30"  value="' . $_POST['usr_land'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_land" size="30"  value="' . $usrUser->GetLand() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_phoneno') . ':</td>');
    if (isset($_POST['usr_phoneno']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_phoneno" size="30"  value="' . $_POST['usr_phoneno'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_phoneno" size="30"  value="' . $usrUser->GetTelephoneNo() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_email') . ':</td>');
    if (isset($_POST['usr_email']))
        $contMain .= echo_sr ('    <td><input type="text" name="usr_email" size="30"  value="' . $_POST['usr_email'] . '"></td>');
    else
        $contMain .= echo_sr ('    <td><input type="text" name="usr_email" size="30"  value="' . $usrUser->GetEmail() . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td></td>');
    $wantsNewsletter = 0;
    if (isset($_POST['usr_newsletter']) && $_POST['usr_newsletter'] == "1")
        $wantsNewsletter = 1;
    else if ($usrUser->WantsNewsletter() == true)
        $wantsNewsletter = 1;
    $contMain .= ('    <td><input type="checkbox" name="usr_newsletter" value="1"');
    if ($wantsNewsletter == 1)
        $contMain .= (' checked');
    $contMain .= echo_sr ('>' . $cTrans->GetTranslation('shop_userprofile_wantsnewsletter') . '</td>');
    $contMain .= echo_sr ('  </tr>');
    if ($usrEdtAction != "edit")  // Checksum for registration only
    {
        $checkSum = rand(10000, 99999);
        $contMain .= echo_sr ('  <tr>');
        $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_userprofile_checksum') . ': <b>' . $checkSum . '</b></td>');
        $contMain .= echo_sr ('    <td><input type="text" name="usr_checksum" size="5" value=""><input type="hidden" name="usr_checksum_org" value="' . $checkSum . '"></td>');
        $contMain .= echo_sr ('  </tr>');
    }
    $contMain .= echo_sr ('</table>');

    $contMain .= build_shop_bottom_links("usr_Save", $cTrans->GetTranslation('shop_userprofile_save'),
                                         "usr_Cancel", $cTrans->GetTranslation('shop_userprofile_cancel'), false);
    if ($usrEdtAction == "edit") // Edit
    {
        $contMain .= echo_sr ('<p align="center">');
        $contMain .= echo_sr ('<input type="button" class="bottom_btn" value="' . $cTrans->GetTranslation('shop_userprofile_delete') . '" onClick="DeleteUserProfile()">');
        $contMain .= echo_sr ('</p>');
    }
    $contMain .= echo_sr ('<input type="hidden" name="usr_EdtAction" value="' . $usrEdtAction . '">');
    if ($usrBackToOrder == true)
        $contMain .= echo_sr ('<input type="hidden" name="usr_BackToOrder" value="1">');
    $contMain .= echo_sr ('<input type="submit" name="usr_DeleteFinal" id="usrFormDeleteBtn" style="visibility: hidden; width: 5px; height: 2px">');
    $contMain .= echo_sr ('</form>');

    $headInject = "";
    $headInject .= echo_sr ('<script type="text/javascript" language="JavaScript">');
    $headInject .= echo_sr ('function DeleteUserProfile()');
    $headInject .= echo_sr ('{');
    $headInject .= echo_sr ('  if (confirm(\'' . $cTrans->GetTranslation('shop_userprofile_deletequest') .'\') == true)');
    $headInject .= echo_sr ('  {');
    $headInject .= echo_sr ('     document.getElementById(\'usrFormDeleteBtn\').click();');
    $headInject .= echo_sr ('  }');
    $headInject .= echo_sr ('}');
    $headInject .= echo_sr ('</script>');
    
    // Additional content
    $contAdditional = "";

    // Put content together
    $contContent = build_site_content($ALIGN_TOP, $contMain, $contAdditional);
    $contPage = fill_content($contPage, $contContent, "", "");
    $contPage = fill_emptyvars($contPage);
    // Add JavaScript to head
    $contPage = inject_into_head($headInject, $contPage, false);
    echo_r($contPage);

?>